/*
 * C compiler
 *
 *  csrc -> asmsrc
 */

#include	"c.h"
#include	"expr.h"
#include	"gen.h"
#include	"cglbdec.h"

//int _flag_2; /* dsactive la restauration de l'cran */

BOOL init_mem(void);
void free_mem(void);
void cleanup(void);

void showMsg(const char *format, ...)
{
  char buffer[256];
  va_list arglist;

  va_start(arglist, format);
  vsprintf(buffer, format, arglist);
  ST_helpMsg(buffer);
}

void _main(void)
{
  // short_option
  // reg_option
  // trans_option
  // opt_option
  // warn_option
  // fpu_option

	//tp_int = tp_short;
	//tp_uint = tp_ushort;
	//int_bits = 16;
  //tp_econst = tp_int;
  //tp_econst.val_flag=1;

  input = fopen("csrc","r");
  if(input == NULL)
    return;
  output = fopen("asmsrc","w");
  remove("cc_error");
  
  if(setjmp(errbuf))
    goto cup;

  if(init_mem())
  {
    out_init();
    initsym();
    getch();
    getsym();
    compile();
  }

cup:
  cleanup();
}

void cleanup(void)
{
	rel_local();
	rel_global();
	free_mem();
	fclose(input);
	fclose(output);
  if(error_count)
    remove("asmsrc");

  showMsg("CC v0.1 - %d error(s), %d warning(s)",
          error_count, warning_count);	
}

void fatal(char *message)
{
  err_print("FATAL: %s", message);
  longjmp(errbuf, 1);
}
