/*
 * C compiler
 * ==========
 *
 * Copyright 1989, 1990, 1991 Christoph van Wuellen.
 * Credits to Matthew Brandt.
 * All commercial rights reserved.
 *
 * This compiler may be redistributed as long there is no
 * commercial interest. The compiler must not be redistributed
 * without its full sources. This notice must stay intact.
 *
 * History:
 *
 * 1989   starting an 68000 C compiler, starting with material
 *        originally by M. Brandt
 * 1990   68000 C compiler further bug fixes
 *        started i386 port (December)
 * 1991   i386 port finished (January)
 *        further corrections in the front end and in the 68000
 *        code generator.
 *        The next port will be a SPARC port
 */

#include	"c.h"
#include	"expr.h"
#include	"gen.h"

/* global definitions	 */

FILE           *input, *output;

unsigned int    nextlabel = 0;
int             lastch = 0;
enum e_sym      lastst = 0;
char            lastid[MAX_ID_LEN+1];
//char            laststr[MAX_STRLEN + 1];
char *laststr;
int             lstrlen = 0;
unsigned long   ival = 0;
#ifndef NOFLOAT
double          rval = 0;
#endif

TABLE           gsyms, gtags, lsyms, labsyms, ltags;

struct slit    *strtab = NULL;
long            lc_auto = 0;
long            max_scratch = 0;
long		act_scratch = 0;
long            lc_bss = 0;
int             global_flag = 0;

unsigned int    save_mask = 0;



/* These are the default options */

int             short_option = 1;
//int		          fpu_option = 0;
int             opt_option = 1;
int		          warn_option = 1;
int             reg_option = 1;


TYP            *ret_type;
int             regptr;
long            reglst[REG_LIST];
int             autoptr;
//long            autolst[AUTO_LIST];
long *autolst = NULL;
struct enode   *init_node = NULL;


TYP             tp_void = {{0, 0}, 0, 0, 1, bt_void, 0, 1};
TYP             tp_long = {{0, 0}, 0, 0, 4, bt_long, 0, 1};
TYP             tp_ulong = {{0, 0}, 0, 0, 4, bt_ulong, 0, 1};
TYP             tp_char = {{0, 0}, 0, 0, 1, bt_char, 0, 1};
TYP             tp_uchar = {{0, 0}, 0, 0, 1, bt_uchar, 0, 1};
TYP             tp_short = {{0, 0}, 0, 0, 2, bt_short, 0, 1};
TYP             tp_ushort = {{0, 0}, 0, 0, 2, bt_ushort, 0, 1};
TYP             tp_float = {{0, 0}, 0, 0, 4, bt_float, 0, 1};

TYP             tp_double = {{0, 0}, 0, 0, 4, bt_double, 0, 1};

TYP             tp_string = {{0, 0}, &tp_char, 0, 4, bt_pointer, 0, 1};
TYP             tp_int = {{0, 0}, 0, 0, 2, bt_short, 0, 1};
TYP             tp_econst = {{0, 0}, 0, 0, 2, bt_short, 1, 1};
TYP             tp_uint = {{0, 0}, 0, 0, 2, bt_ushort, 0, 1};
TYP             tp_func = {{0, 0}, &tp_int, 0, 4, bt_func, 1, 1};

int             int_bits = 16;


struct amode    push = {am_adec, 0, STACKPTR - 8, 0, 0},
                pop =  {am_ainc, 0, STACKPTR - 8, 0, 0};

int		uses_structassign = 0;
int		regs_used = 0;
int		is_leaf_function = 0;


TYP            *head = 0, *tail = 0;

int error_count = 0, warning_count = 0;
jmp_buf errbuf;
