// Snake
#define USE_TI89
#include <tigcclib.h>

#define WY (88/4)
#define WX (160/4)

enum
{
  Void, Right, Up, Left,
  Down, Dot, Wall
};

void rect(int x1, int y1, int x2, int y2, int c)
{
  DrawLine(x1,y1,x2,y1,c);
  DrawLine(x2,y1,x2,y2,c);
  DrawLine(x2,y2,x1,y2,c);
  DrawLine(x1,y2,x1,y1,c);
}

void big_pix(int x, int y, int c)
{
  x*=4;
  y*=4;
  rect(x,y+10,x+3,y+13,c);
}

void new_dot(char world[WY][WX])
{
  int x,y;

  do {
   x = random(WX);
   y = random(WY);
  } while(world[y][x]);

  world[y][x] = Dot;
  big_pix(x,y,A_NORMAL);
}

void game(void)
{
  char world[WY][WX];
  int i, k;
  int timer, score = 0;
  int ldir, dir = Right;
  int size_inc = 0;

  int hdx,hdy;
  int tlx,tly;

  FontSetSys(F_8x10);
  DrawStr(0,0,"SNAKE",A_NORMAL);

  for(i=1; i<4; i++)
    rect(i,i+10,WX*4-1-i,WY*4+9-i,A_NORMAL);

  for(k=0; k<WY; k++)
    for(i=0; i<WX; i++)
      world[k][i] = Void;

  for(i=0; i<WX; i++)
    world[0][i] = world[WY-1][i] = Wall;
  for(i=0; i<WY; i++)
    world[i][0] = world[i][WX-1] = Wall;

  hdx=hdy=tlx=tly=10;
  world[hdy][hdx] = Dot;

  do {
    ldir = dir;
    timer = 999;

    k = 0;
    while(--timer)
    {
      if(kbhit())
        k = ngetchx();

      if(k==KEY_RIGHT && ldir!=Left)
        dir = Right;
      if(k==KEY_LEFT && ldir!=Right)
        dir = Left;
      if(k==KEY_UP && ldir!=Down)
        dir = Up;
      if(k==KEY_DOWN && ldir!=Up)
        dir = Down;
    }

    world[hdy][hdx] = dir;
    switch(dir)
    {
      case Right:
        hdx++;
        break;
      case Left:
        hdx--;
        break;
      case Down:
        hdy++;
        break;
      case Up:
        hdy--;
    }

    i = world[hdy][hdx];
    if(i == Dot)
    {
      size_inc = 5;
      new_dot(world);
    }
    else if(i)
      return

    big_pix(hdx,hdy,A_NORMAL);

    if(size_inc)
    {
      size_inc--;
      score++;
    }
    else
    {
      i = world[tly][tlx];
      world[tly][tlx] = 0;
      big_pix(tlx,tly,A_REVERSE);
      switch(i)
      {
        case Right:
          tlx++;
          break;
        case Left:
          tlx--;
          break;
        case Down:
          tly++;
          break;
        case Up:
          tly--;
      }
    }
//    _text(136,0,C_BLACK,T_LARGE,"%03ld",score)
  } while(k != KEY_ESC);
}

void _main(void)
{
  char screen[LCD_SIZE];
  memcpy(screen, LCD_MEM, LCD_SIZE);
  memset(LCD_MEM, 0, LCD_SIZE);
  game();
  memcpy(LCD_MEM, screen, LCD_SIZE);
}
